-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Localization - Using Globalize
Backend API
$(() => {
const dictionary = {
en: {
Number: 'Number',
Contact: 'Contact',
Company: 'Company',
Amount: 'Amount',
PaymentDate: 'Payment Date',
},
de: {
Number: 'Nummer',
Contact: 'Ansprechpartner',
Company: 'Firma',
Amount: 'Betrag',
PaymentDate: 'Zahlungsdatum',
},
ru: {
Number: 'Номер',
Contact: 'Имя',
Company: 'Организация',
Amount: 'Сумма',
PaymentDate: 'Дата оплаты',
},
};
Globalize.loadMessages(dictionary);
const locale = getLocale();
Globalize.locale(locale);
const locales = [
{ name: 'English', value: 'en' },
{ name: 'Deutsch', value: 'de' },
{ name: 'Русский', value: 'ru' },
];
const dataGridOptions = {
dataSource: payments,
columns: [{
dataField: 'PaymentId',
caption: Globalize.formatMessage('Number'),
allowEditing: false,
width: '100px',
}, {
dataField: 'ContactName',
caption: Globalize.formatMessage('Contact'),
}, {
dataField: 'CompanyName',
caption: Globalize.formatMessage('Company'),
}, {
dataField: 'Amount',
caption: Globalize.formatMessage('Amount'),
dataType: 'number',
format: 'currency',
editorOptions: {
format: 'currency',
showClearButton: true,
},
}, {
dataField: 'PaymentDate',
caption: Globalize.formatMessage('PaymentDate'),
dataType: 'date',
}],
filterRow: {
visible: true,
applyFilter: 'auto',
},
editing: {
mode: 'popup',
allowUpdating: true,
popup: {
width: 700,
height: 345,
},
},
};
const selectBoxOptions = {
inputAttr: { id: 'selectInput' },
dataSource: locales,
displayExpr: 'name',
valueExpr: 'value',
value: locale,
onValueChanged: changeLocale,
};
function changeLocale(data) {
setLocale(data.value);
document.location.reload();
}
function getLocale() {
const storageLocale = sessionStorage.getItem('locale');
return storageLocale != null ? storageLocale : 'en';
}
function setLocale(savingLocale) {
sessionStorage.setItem('locale', savingLocale);
}
$('#gridContainer').dxDataGrid(dataGridOptions);
$('#selectBox').dxSelectBox(selectBoxOptions);
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/cldrjs@0.5.5/dist/cldr.js"></script>
<script src="https://cdn.jsdelivr.net/npm/cldrjs@0.5.5/dist/cldr/event.js"></script>
<script src="https://cdn.jsdelivr.net/npm/cldrjs@0.5.5/dist/cldr/supplemental.js"></script>
<script src="https://cdn.jsdelivr.net/npm/cldrjs@0.5.5/dist/cldr/unresolved.js"></script>
<script src="https://cdn.jsdelivr.net/npm/globalize@1.7.1/dist/globalize.js"></script>
<script src="https://cdn.jsdelivr.net/npm/globalize@1.7.1/dist/globalize/message.js"></script>
<script src="https://cdn.jsdelivr.net/npm/globalize@1.7.1/dist/globalize/number.js"></script>
<script src="https://cdn.jsdelivr.net/npm/globalize@1.7.1/dist/globalize/currency.js"></script>
<script src="https://cdn.jsdelivr.net/npm/globalize@1.7.1/dist/globalize/date.js"></script>
<script src="js/dx.all.js?v=26.1.4"></script>
<script src="https://cdn3.devexpress.com/jslib/26.1.4/js/localization/dx.messages.de.js"></script>
<script src="https://cdn3.devexpress.com/jslib/26.1.4/js/localization/dx.messages.ru.js"></script>
<script src="https://cdn.jsdelivr.net/npm/devextreme-cldr-data@1.0.3/supplemental.js"></script>
<script src="https://cdn.jsdelivr.net/npm/devextreme-cldr-data@1.0.3/de.js"></script>
<script src="https://cdn.jsdelivr.net/npm/devextreme-cldr-data@1.0.3/ru.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="data-grid-demo">
<div id="gridContainer"></div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<label for="selectBox">Language</label>
<div id="selectBox"></div>
</div>
</div>
</div>
</div>
</body>
</html>
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
.option {
margin-top: 10px;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option > label {
margin-right: 10px;
}
.option > .dx-selectbox {
display: inline-block;
vertical-align: middle;
}
const payments = [{
PaymentId: 1,
ContactName: 'Nancy Davolio',
CompanyName: 'Premier Buy',
Amount: 1740,
PaymentDate: '2013/01/06',
},
{
PaymentId: 2,
ContactName: 'Andrew Fuller',
CompanyName: 'ElectrixMax',
Amount: 850,
PaymentDate: '2013/01/13',
},
{
PaymentId: 3,
ContactName: 'Janet Leverling',
CompanyName: 'Video Emporium',
Amount: 2235,
PaymentDate: '2013/01/07',
},
{
PaymentId: 4,
ContactName: 'Margaret Peacock',
CompanyName: 'Screen Shop',
Amount: 1965,
PaymentDate: '2013/01/03',
},
{
PaymentId: 5,
ContactName: 'Steven Buchanan',
CompanyName: 'Braeburn',
Amount: 880,
PaymentDate: '2013/01/10',
},
{
PaymentId: 6,
ContactName: 'Michael Suyama',
CompanyName: 'PriceCo',
Amount: 5260,
PaymentDate: '2013/01/17',
},
{
PaymentId: 7,
ContactName: 'Robert King',
CompanyName: 'Ultimate Gadget',
Amount: 2790,
PaymentDate: '2013/01/21',
},
{
PaymentId: 8,
ContactName: 'Laura Callahan',
CompanyName: 'EZ Stop',
Amount: 3140,
PaymentDate: '2013/01/01',
},
{
PaymentId: 9,
ContactName: 'Anne Dodsworth',
CompanyName: 'Clicker',
Amount: 6175,
PaymentDate: '2013/01/24',
},
{
PaymentId: 10,
ContactName: 'Clark Morgan',
CompanyName: 'Store of America',
Amount: 4575,
PaymentDate: '2013/01/11',
}];
To localize components with Globalize, link modules, CLDR scripts, and DevExtreme dictionaries for the target locales. Load the CLDR data for these locales. If following a modular approach, import the necessary components. Set the current locale with the Globalize.locale method.

Backend API
<div id="data-grid-demo">
<dx-data-grid [dataSource]="payments">
<dxi-data-grid-column
dataField="PaymentId"
[caption]="formatMessage('Number')"
[allowEditing]="false"
width="100"
>
</dxi-data-grid-column>
<dxi-data-grid-column
dataField="ContactName"
[caption]="formatMessage('Contact')"
>
</dxi-data-grid-column>
<dxi-data-grid-column
dataField="CompanyName"
[caption]="formatMessage('Company')"
>
</dxi-data-grid-column>
<dxi-data-grid-column
dataField="Amount"
[caption]="formatMessage('Amount')"
dataType="number"
format="currency"
[editorOptions]="{
format: 'currency',
showClearButton: true
}"
>
</dxi-data-grid-column>
<dxi-data-grid-column
dataField="PaymentDate"
[caption]="formatMessage('PaymentDate')"
dataType="date"
>
</dxi-data-grid-column>
<dxo-data-grid-filter-row [visible]="true" [applyFilter]="'auto'">
</dxo-data-grid-filter-row>
<dxo-data-grid-editing mode="popup" [allowUpdating]="true">
<dxo-data-grid-popup [width]="700" [height]="345"> </dxo-data-grid-popup>
</dxo-data-grid-editing>
</dx-data-grid>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<label for="selectInput">Language</label>
<dx-select-box
id="selectBox"
[dataSource]="locales"
[inputAttr]="{ 'aria-label': 'Language' }"
displayExpr="Name"
valueExpr="Value"
[value]="locale"
(onValueChanged)="changeLocale($event)"
[inputAttr]="{ id: 'selectInput' }"
>
</dx-select-box>
</div>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxSelectBoxModule, DxDataGridModule } from 'devextreme-angular';
import 'devextreme/common/core/localization/globalize/number';
import 'devextreme/common/core/localization/globalize/date';
import 'devextreme/common/core/localization/globalize/currency';
import 'devextreme/common/core/localization/globalize/message';
// import 'devextreme-angular/common/core/localization';
import deMessages from 'npm:devextreme/localization/messages/de.json!json';
import ruMessages from 'npm:devextreme/localization/messages/ru.json!json';
import deCldrData from 'npm:devextreme-cldr-data/de.json!json';
import ruCldrData from 'npm:devextreme-cldr-data/ru.json!json';
import supplementalCldrData from 'npm:devextreme-cldr-data/supplemental.json!json';
import Globalize from 'globalize';
import { Locale, Payment, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
preserveWhitespaces: true,
imports: [
DxSelectBoxModule,
DxDataGridModule,
],
})
export class AppComponent {
locale: string;
locales: Locale[];
payments: Payment[];
formatMessage = Globalize.formatMessage.bind(Globalize);
constructor(private service: Service) {
this.locale = this.getLocale();
this.payments = service.getPayments();
this.locales = service.getLocales();
this.initGlobalize();
Globalize.locale(this.locale);
}
initGlobalize() {
Globalize.load(
deCldrData,
ruCldrData,
supplementalCldrData,
);
Globalize.loadMessages(deMessages);
Globalize.loadMessages(ruMessages);
Globalize.loadMessages(this.service.getDictionary());
}
changeLocale(data) {
this.setLocale(data.value);
parent.document.location.reload();
}
getLocale() {
const locale = sessionStorage.getItem('locale');
return locale != null ? locale : 'en';
}
setLocale(locale) {
sessionStorage.setItem('locale', locale);
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
.option {
margin-top: 10px;
}
.caption {
font-size: 18px;
font-weight: 500;
}
::ng-deep .option > label {
margin-right: 10px;
}
::ng-deep .option > .dx-selectbox {
display: inline-block;
vertical-align: middle;
}
import { Injectable } from '@angular/core';
export class Locale {
Name: string;
Value: string;
}
const locales: Locale[] = [{
Name: 'English',
Value: 'en',
}, {
Name: 'Deutsch',
Value: 'de',
}, {
Name: 'Русский',
Value: 'ru',
}];
export class Payment {
PaymentId: number;
ContactName: string;
CompanyName: string;
Amount: number;
PaymentDate: string;
}
const payments: Payment[] = [{
PaymentId: 1,
ContactName: 'Nancy Davolio',
CompanyName: 'Premier Buy',
Amount: 1740,
PaymentDate: '2013/01/06',
},
{
PaymentId: 2,
ContactName: 'Andrew Fuller',
CompanyName: 'ElectrixMax',
Amount: 850,
PaymentDate: '2013/01/13',
},
{
PaymentId: 3,
ContactName: 'Janet Leverling',
CompanyName: 'Video Emporium',
Amount: 2235,
PaymentDate: '2013/01/07',
},
{
PaymentId: 4,
ContactName: 'Margaret Peacock',
CompanyName: 'Screen Shop',
Amount: 1965,
PaymentDate: '2013/01/03',
},
{
PaymentId: 5,
ContactName: 'Steven Buchanan',
CompanyName: 'Braeburn',
Amount: 880,
PaymentDate: '2013/01/10',
},
{
PaymentId: 6,
ContactName: 'Michael Suyama',
CompanyName: 'PriceCo',
Amount: 5260,
PaymentDate: '2013/01/17',
},
{
PaymentId: 7,
ContactName: 'Robert King',
CompanyName: 'Ultimate Gadget',
Amount: 2790,
PaymentDate: '2013/01/21',
},
{
PaymentId: 8,
ContactName: 'Laura Callahan',
CompanyName: 'EZ Stop',
Amount: 3140,
PaymentDate: '2013/01/01',
},
{
PaymentId: 9,
ContactName: 'Anne Dodsworth',
CompanyName: 'Clicker',
Amount: 6175,
PaymentDate: '2013/01/24',
},
{
PaymentId: 10,
ContactName: 'Clark Morgan',
CompanyName: 'Store of America',
Amount: 4575,
PaymentDate: '2013/01/11',
}];
export class PaymentView {
Number: string;
Contact: string;
Company: string;
Amount: string;
PaymentDate: string;
}
export class Dictionary {
[key: string]: PaymentView;
}
const dictionary: Dictionary = {
en: {
Number: 'Number',
Contact: 'Contact',
Company: 'Company',
Amount: 'Amount',
PaymentDate: 'Payment Date',
},
de: {
Number: 'Nummer',
Contact: 'Ansprechpartner',
Company: 'Firma',
Amount: 'Betrag',
PaymentDate: 'Zahlungsdatum',
},
ru: {
Number: 'Номер',
Contact: 'Имя',
Company: 'Организация',
Amount: 'Сумма',
PaymentDate: 'Дата оплаты',
},
};
@Injectable()
export class Service {
getPayments() {
return payments;
}
getLocales() {
return locales;
}
getDictionary() {
return dictionary;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'globalize': 'npm:globalize@1.7.1/dist/globalize',
'json': 'npm:systemjs-plugin-json@0.3.0/json.js',
'cldr': 'npm:cldrjs@0.5.5/dist/cldr',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'globalize': {
main: '../globalize.js',
defaultExtension: 'js',
},
'cldr': {
main: '../cldr.js',
defaultExtension: 'js',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
declare module 'npm:devextreme-cldr-data/de.json!json' {
const json: object;
export = json;
}
declare module 'npm:devextreme-cldr-data/ru.json!json' {
const json: object;
export = json;
}
declare module 'npm:devextreme-cldr-data/supplemental.json!json' {
const json: object;
export = json;
}
To localize components with Globalize, link modules, CLDR scripts, and DevExtreme dictionaries for the target locales. Load the CLDR data for these locales. If following a modular approach, import the necessary components. Set the current locale with the Globalize.locale method.

Backend API
import React, { useState } from 'react';
import DataGrid, { Column, Editing, FilterRow } from 'devextreme-react/data-grid';
import SelectBox, { type SelectBoxTypes } from 'devextreme-react/select-box';
import 'devextreme/common/core/localization/globalize/number';
import 'devextreme/common/core/localization/globalize/date';
import 'devextreme/common/core/localization/globalize/currency';
import 'devextreme/common/core/localization/globalize/message';
import deMessages from 'devextreme/localization/messages/de.json';
import ruMessages from 'devextreme/localization/messages/ru.json';
import deCldrData from 'devextreme-cldr-data/de.json';
import ruCldrData from 'devextreme-cldr-data/ru.json';
import supplementalCldrData from 'devextreme-cldr-data/supplemental.json';
import Globalize from 'globalize';
import service from './data.ts';
const editPopupOptions = {
width: 700,
height: 345,
};
const amountEditorOptions = {
format: 'currency',
showClearButton: true,
};
const selectBoxInputAttr = { id: 'selectInput' };
Globalize.load(
deCldrData,
ruCldrData,
supplementalCldrData,
);
Globalize.loadMessages(deMessages);
Globalize.loadMessages(ruMessages);
Globalize.loadMessages(service.getDictionary());
Globalize.locale(sessionStorage.getItem('locale') || 'en');
const App = () => {
const [locale, setLocale] = useState(sessionStorage.getItem('locale') || 'en');
const locales = service.getLocales();
const payments = service.getPayments();
const changeLocale = (e: SelectBoxTypes.ValueChangedEvent) => {
setLocale(e.value);
sessionStorage.setItem('locale', e.value);
document.location.reload();
};
return (
<div>
<DataGrid
dataSource={payments}
keyExpr="PaymentId"
>
<Editing
mode="popup"
allowUpdating={true}
popup={editPopupOptions}
/>
<FilterRow
visible={true}
applyFilter="auto"
/>
<Column
dataField="PaymentId"
caption={Globalize.formatMessage('Number')}
allowEditing={false}
width={100}
/>
<Column
dataField="ContactName"
caption={Globalize.formatMessage('Contact')}
/>
<Column
dataField="CompanyName"
caption={Globalize.formatMessage('Company')}
/>
<Column
dataField="Amount"
caption={Globalize.formatMessage('Amount')}
dataType="number"
format="currency"
editorOptions={amountEditorOptions}
/>
<Column
dataField="PaymentDate"
caption={Globalize.formatMessage('PaymentDate')}
dataType="date"
/>
</DataGrid>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<label htmlFor="selectInput">Language</label>
<SelectBox
items={locales}
valueExpr="Value"
displayExpr="Name"
value={locale}
onValueChanged={changeLocale}
inputAttr={selectBoxInputAttr}
/>
</div>
</div>
</div>
);
};
export default App;
import React, { useState } from 'react';
import DataGrid, { Column, Editing, FilterRow } from 'devextreme-react/data-grid';
import SelectBox from 'devextreme-react/select-box';
import 'devextreme/common/core/localization/globalize/number';
import 'devextreme/common/core/localization/globalize/date';
import 'devextreme/common/core/localization/globalize/currency';
import 'devextreme/common/core/localization/globalize/message';
import deMessages from 'devextreme/localization/messages/de.json';
import ruMessages from 'devextreme/localization/messages/ru.json';
import deCldrData from 'devextreme-cldr-data/de.json';
import ruCldrData from 'devextreme-cldr-data/ru.json';
import supplementalCldrData from 'devextreme-cldr-data/supplemental.json';
import Globalize from 'globalize';
import service from './data.js';
const editPopupOptions = {
width: 700,
height: 345,
};
const amountEditorOptions = {
format: 'currency',
showClearButton: true,
};
const selectBoxInputAttr = { id: 'selectInput' };
Globalize.load(deCldrData, ruCldrData, supplementalCldrData);
Globalize.loadMessages(deMessages);
Globalize.loadMessages(ruMessages);
Globalize.loadMessages(service.getDictionary());
Globalize.locale(sessionStorage.getItem('locale') || 'en');
const App = () => {
const [locale, setLocale] = useState(sessionStorage.getItem('locale') || 'en');
const locales = service.getLocales();
const payments = service.getPayments();
const changeLocale = (e) => {
setLocale(e.value);
sessionStorage.setItem('locale', e.value);
document.location.reload();
};
return (
<div>
<DataGrid
dataSource={payments}
keyExpr="PaymentId"
>
<Editing
mode="popup"
allowUpdating={true}
popup={editPopupOptions}
/>
<FilterRow
visible={true}
applyFilter="auto"
/>
<Column
dataField="PaymentId"
caption={Globalize.formatMessage('Number')}
allowEditing={false}
width={100}
/>
<Column
dataField="ContactName"
caption={Globalize.formatMessage('Contact')}
/>
<Column
dataField="CompanyName"
caption={Globalize.formatMessage('Company')}
/>
<Column
dataField="Amount"
caption={Globalize.formatMessage('Amount')}
dataType="number"
format="currency"
editorOptions={amountEditorOptions}
/>
<Column
dataField="PaymentDate"
caption={Globalize.formatMessage('PaymentDate')}
dataType="date"
/>
</DataGrid>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<label htmlFor="selectInput">Language</label>
<SelectBox
items={locales}
valueExpr="Value"
displayExpr="Name"
value={locale}
onValueChanged={changeLocale}
inputAttr={selectBoxInputAttr}
/>
</div>
</div>
</div>
);
};
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
const payments = [
{
PaymentId: 1,
ContactName: 'Nancy Davolio',
CompanyName: 'Premier Buy',
Amount: 1740,
PaymentDate: '2013/01/06',
},
{
PaymentId: 2,
ContactName: 'Andrew Fuller',
CompanyName: 'ElectrixMax',
Amount: 850,
PaymentDate: '2013/01/13',
},
{
PaymentId: 3,
ContactName: 'Janet Leverling',
CompanyName: 'Video Emporium',
Amount: 2235,
PaymentDate: '2013/01/07',
},
{
PaymentId: 4,
ContactName: 'Margaret Peacock',
CompanyName: 'Screen Shop',
Amount: 1965,
PaymentDate: '2013/01/03',
},
{
PaymentId: 5,
ContactName: 'Steven Buchanan',
CompanyName: 'Braeburn',
Amount: 880,
PaymentDate: '2013/01/10',
},
{
PaymentId: 6,
ContactName: 'Michael Suyama',
CompanyName: 'PriceCo',
Amount: 5260,
PaymentDate: '2013/01/17',
},
{
PaymentId: 7,
ContactName: 'Robert King',
CompanyName: 'Ultimate Gadget',
Amount: 2790,
PaymentDate: '2013/01/21',
},
{
PaymentId: 8,
ContactName: 'Laura Callahan',
CompanyName: 'EZ Stop',
Amount: 3140,
PaymentDate: '2013/01/01',
},
{
PaymentId: 9,
ContactName: 'Anne Dodsworth',
CompanyName: 'Clicker',
Amount: 6175,
PaymentDate: '2013/01/24',
},
{
PaymentId: 10,
ContactName: 'Clark Morgan',
CompanyName: 'Store of America',
Amount: 4575,
PaymentDate: '2013/01/11',
},
];
const locales = [
{
Name: 'English',
Value: 'en',
},
{
Name: 'Deutsch',
Value: 'de',
},
{
Name: 'Русский',
Value: 'ru',
},
];
const dictionary = {
en: {
Number: 'Number',
Contact: 'Contact',
Company: 'Company',
Amount: 'Amount',
PaymentDate: 'Payment Date',
},
de: {
Number: 'Nummer',
Contact: 'Ansprechpartner',
Company: 'Firma',
Amount: 'Betrag',
PaymentDate: 'Zahlungsdatum',
},
ru: {
Number: 'Номер',
Contact: 'Имя',
Company: 'Организация',
Amount: 'Сумма',
PaymentDate: 'Дата оплаты',
},
};
export default {
getPayments() {
return payments;
},
getLocales() {
return locales;
},
getDictionary() {
return dictionary;
},
};
declare module '*.json' {
const value: any;
export default value;
}
declare module 'globalize' {
const Globalize: any;
export default Globalize;
}
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'globalize': 'npm:globalize@1.7.1/dist/globalize',
'json': 'npm:systemjs-plugin-json@0.3.0/json.js',
'cldr': 'npm:cldrjs@0.5.5/dist/cldr',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'devextreme-cldr-data': {
format: 'json',
defaultExtension: 'json',
},
'globalize': {
main: '../globalize.js',
defaultExtension: 'js',
},
'cldr': {
main: '../cldr.js',
defaultExtension: 'js',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
const payments = [
{
PaymentId: 1,
ContactName: 'Nancy Davolio',
CompanyName: 'Premier Buy',
Amount: 1740,
PaymentDate: '2013/01/06',
},
{
PaymentId: 2,
ContactName: 'Andrew Fuller',
CompanyName: 'ElectrixMax',
Amount: 850,
PaymentDate: '2013/01/13',
},
{
PaymentId: 3,
ContactName: 'Janet Leverling',
CompanyName: 'Video Emporium',
Amount: 2235,
PaymentDate: '2013/01/07',
},
{
PaymentId: 4,
ContactName: 'Margaret Peacock',
CompanyName: 'Screen Shop',
Amount: 1965,
PaymentDate: '2013/01/03',
},
{
PaymentId: 5,
ContactName: 'Steven Buchanan',
CompanyName: 'Braeburn',
Amount: 880,
PaymentDate: '2013/01/10',
},
{
PaymentId: 6,
ContactName: 'Michael Suyama',
CompanyName: 'PriceCo',
Amount: 5260,
PaymentDate: '2013/01/17',
},
{
PaymentId: 7,
ContactName: 'Robert King',
CompanyName: 'Ultimate Gadget',
Amount: 2790,
PaymentDate: '2013/01/21',
},
{
PaymentId: 8,
ContactName: 'Laura Callahan',
CompanyName: 'EZ Stop',
Amount: 3140,
PaymentDate: '2013/01/01',
},
{
PaymentId: 9,
ContactName: 'Anne Dodsworth',
CompanyName: 'Clicker',
Amount: 6175,
PaymentDate: '2013/01/24',
},
{
PaymentId: 10,
ContactName: 'Clark Morgan',
CompanyName: 'Store of America',
Amount: 4575,
PaymentDate: '2013/01/11',
},
];
const locales = [
{
Name: 'English',
Value: 'en',
},
{
Name: 'Deutsch',
Value: 'de',
},
{
Name: 'Русский',
Value: 'ru',
},
];
const dictionary = {
en: {
Number: 'Number',
Contact: 'Contact',
Company: 'Company',
Amount: 'Amount',
PaymentDate: 'Payment Date',
},
de: {
Number: 'Nummer',
Contact: 'Ansprechpartner',
Company: 'Firma',
Amount: 'Betrag',
PaymentDate: 'Zahlungsdatum',
},
ru: {
Number: 'Номер',
Contact: 'Имя',
Company: 'Организация',
Amount: 'Сумма',
PaymentDate: 'Дата оплаты',
},
};
export default {
getPayments() {
return payments;
},
getLocales() {
return locales;
},
getDictionary() {
return dictionary;
},
};
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
.option {
margin-top: 10px;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option > label {
margin-right: 10px;
}
.option > .dx-selectbox {
display: inline-block;
vertical-align: middle;
}
To localize components with Globalize, link modules, CLDR scripts, and DevExtreme dictionaries for the target locales. Load the CLDR data for these locales. If following a modular approach, import the necessary components. Set the current locale with the Globalize.locale method.

Backend API
<template>
<div>
<DxDataGrid
:data-source="payments"
key-expr="PaymentId"
>
<DxEditing
:allow-updating="true"
:popup="editPopupOptions"
mode="popup"
/>
<DxFilterRow
:visible="true"
apply-filter="auto"
/>
<DxColumn
:caption="formatMessage('Number')"
:allow-editing="false"
:width="100"
data-field="PaymentId"
/>
<DxColumn
:caption="formatMessage('Contact')"
data-field="ContactName"
/>
<DxColumn
:caption="formatMessage('Company')"
data-field="CompanyName"
/>
<DxColumn
:caption="formatMessage('Amount')"
:editor-options="amountEditorOptions"
data-field="Amount"
data-type="number"
format="currency"
/>
<DxColumn
:caption="formatMessage('PaymentDate')"
data-field="PaymentDate"
data-type="date"
/>
</DxDataGrid>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<label for="selectInput">Language </label>
<DxSelectBox
:data-source="locales"
:value="locale"
:input-attr="selectBoxInputAttr"
value-expr="Value"
display-expr="Name"
@valueChanged="changeLocale($event)"
/>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { onBeforeMount, ref } from 'vue';
import {
DxDataGrid, DxColumn, DxEditing, DxFilterRow,
} from 'devextreme-vue/data-grid';
import DxSelectBox, { type DxSelectBoxTypes } from 'devextreme-vue/select-box';
import 'devextreme/common/core/localization/globalize/number';
import 'devextreme/common/core/localization/globalize/date';
import 'devextreme/common/core/localization/globalize/currency';
import 'devextreme/common/core/localization/globalize/message';
import deMessages from 'npm:devextreme/localization/messages/de.json!json';
import ruMessages from 'npm:devextreme/localization/messages/ru.json!json';
import deCldrData from 'npm:devextreme-cldr-data/de.json!json';
import ruCldrData from 'npm:devextreme-cldr-data/ru.json!json';
import supplementalCldrData from 'npm:devextreme-cldr-data/supplemental.json!json';
import Globalize from 'globalize';
import service from './data.ts';
type Locale = string;
const locales: { Name: string, Value: Locale }[] = service.getLocales();
const payments: Record<string, string | number>[] = service.getPayments();
const locale: Locale = getLocale();
const editPopupOptions = { width: 700, height: 345 };
const amountEditorOptions = { format: 'currency', showClearButton: true };
const selectBoxInputAttr = { id: 'selectInput' };
const formatMessage = ref((msg: string) => msg);
onBeforeMount(() => {
initGlobalize();
});
function getLocale(): Locale {
const savedLocale = sessionStorage.getItem('locale');
return savedLocale != null ? savedLocale : 'en';
}
function setLocale(newLocale: Locale) {
sessionStorage.setItem('locale', newLocale);
}
function initGlobalize() {
Globalize.load(
deCldrData,
ruCldrData,
supplementalCldrData,
);
Globalize.loadMessages(deMessages);
Globalize.loadMessages(ruMessages);
Globalize.loadMessages(service.getDictionary());
Globalize.locale(locale);
formatMessage.value = Globalize.formatMessage.bind(Globalize);
}
function changeLocale({ value }: DxSelectBoxTypes.ValueChangedEvent) {
setLocale(value);
document.location.reload();
}
</script>
<style scoped>
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
}
.option {
margin-top: 10px;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option > label {
margin-right: 10px;
}
.option > .dx-selectbox {
display: inline-block;
vertical-align: middle;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'globalize': 'npm:globalize@1.7.1/dist/globalize',
'json': 'npm:systemjs-plugin-json@0.3.0/json.js',
'cldr': 'npm:cldrjs@0.5.5/dist/cldr',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'devextreme-cldr-data': {
format: 'json',
defaultExtension: 'json',
},
'globalize': {
main: '../globalize.js',
defaultExtension: 'js',
},
'cldr': {
main: '../cldr.js',
defaultExtension: 'js',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
const payments = [
{
PaymentId: 1,
ContactName: 'Nancy Davolio',
CompanyName: 'Premier Buy',
Amount: 1740,
PaymentDate: '2013/01/06',
},
{
PaymentId: 2,
ContactName: 'Andrew Fuller',
CompanyName: 'ElectrixMax',
Amount: 850,
PaymentDate: '2013/01/13',
},
{
PaymentId: 3,
ContactName: 'Janet Leverling',
CompanyName: 'Video Emporium',
Amount: 2235,
PaymentDate: '2013/01/07',
},
{
PaymentId: 4,
ContactName: 'Margaret Peacock',
CompanyName: 'Screen Shop',
Amount: 1965,
PaymentDate: '2013/01/03',
},
{
PaymentId: 5,
ContactName: 'Steven Buchanan',
CompanyName: 'Braeburn',
Amount: 880,
PaymentDate: '2013/01/10',
},
{
PaymentId: 6,
ContactName: 'Michael Suyama',
CompanyName: 'PriceCo',
Amount: 5260,
PaymentDate: '2013/01/17',
},
{
PaymentId: 7,
ContactName: 'Robert King',
CompanyName: 'Ultimate Gadget',
Amount: 2790,
PaymentDate: '2013/01/21',
},
{
PaymentId: 8,
ContactName: 'Laura Callahan',
CompanyName: 'EZ Stop',
Amount: 3140,
PaymentDate: '2013/01/01',
},
{
PaymentId: 9,
ContactName: 'Anne Dodsworth',
CompanyName: 'Clicker',
Amount: 6175,
PaymentDate: '2013/01/24',
},
{
PaymentId: 10,
ContactName: 'Clark Morgan',
CompanyName: 'Store of America',
Amount: 4575,
PaymentDate: '2013/01/11',
},
];
const locales = [
{
Name: 'English',
Value: 'en',
},
{
Name: 'Deutsch',
Value: 'de',
},
{
Name: 'Русский',
Value: 'ru',
},
];
const dictionary = {
en: {
Number: 'Number',
Contact: 'Contact',
Company: 'Company',
Amount: 'Amount',
PaymentDate: 'Payment Date',
},
de: {
Number: 'Nummer',
Contact: 'Ansprechpartner',
Company: 'Firma',
Amount: 'Betrag',
PaymentDate: 'Zahlungsdatum',
},
ru: {
Number: 'Номер',
Contact: 'Имя',
Company: 'Организация',
Amount: 'Сумма',
PaymentDate: 'Дата оплаты',
},
};
export default {
getPayments() {
return payments;
},
getLocales() {
return locales;
},
getDictionary() {
return dictionary;
},
};
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
declare module 'npm:devextreme/localization/messages/de.json!json' {
const json: object;
export default json;
}
declare module 'npm:devextreme/localization/messages/ru.json!json' {
const json: object;
export default json;
}
declare module 'npm:devextreme-cldr-data/de.json!json' {
const json: object;
export default json;
}
declare module 'npm:devextreme-cldr-data/ru.json!json' {
const json: object;
export default json;
}
declare module 'npm:devextreme-cldr-data/supplemental.json!json' {
const json: object;
export default json;
}
declare module 'globalize' {
const Globalize: {
load: (...args: object[]) => void;
loadMessages: (messages: object) => void;
locale: (locale: string) => void;
formatMessage: (key: string, ...args: unknown[]) => string;
};
export default Globalize;
}
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
To localize components with Globalize, link modules, CLDR scripts, and DevExtreme dictionaries for the target locales. Load the CLDR data for these locales. If following a modular approach, import the necessary components. Set the current locale with the Globalize.locale method.